/*    30 10 01                                                       */
/*    26 05 97                                                       */
/*    26/09/95                                                       */
/* utilisation de Numrical Recipies (en Fortran!) p 390!            */ 
/* dfour1.c                                                          */
/* transformee de Fourier en DOUBLE precision                        */
/*            j=N-1                                                  */
/*             ___                                                   */
/*      ^      \          I k (2 Pi j/N)                             */
/*      u   =  /    u    e                                           */
/*       k     ---   j                                               */
/*             j=0                                                   */
/*                                                                   */
/* remarquer que les valeurs sont prises en xj=(2 Pi j/N)            */ 
/*                                                                   */
/* La TF inverse s'ecrit alors                                       */
/*            k=N-1                                                  */
/*             ___                                                   */
/*             \    ^     -I k (2 Pi j/N)                            */
/*      u   =  /    u    e                                           */
/*       j     ---   k                                               */
/*             k=0                                                   */
/*                                                                   */
/* La derivation s'ecrit alors                                       */
/*            k=N-1                                                  */
/*             ___                                                   */
/*     d       \    ^            -I k (2 Pi j/N)                     */
/*     -- u =  /    u  (- I k)  e                                    */
/*     dx  j   ---   k                                               */
/*             k=0                                                   */
/*                                                                   */
/*                                                                   */
/*      ACHTUNG !!!!!                                                */
/*            les variations sont entre -Pi et Pi                    */
/*                     => correction des drives                    */
/*                    d'ou le facteur    (Pi/Lx)                     */
/* ================================================================  */ 

#include <stdio.h>
#include <stdlib.h>
#include "math.h"
#include "param.h"
#define Power pow
/*#include "unix.h"*/

void next( )
{ 
  extern double  dx,t,dt,Pi,Lx,UN;
  extern int   nx,NLin;
  extern double epsilon,delta2,visc,sigma;
  extern double* u;
  extern double* TFu;
  extern double* TFdu;
  extern double* TFdu2;
  extern double* uo;
  extern double* Espect; 
  double k,L,expL,expLm1;
  double ur,ui,Lr,Li,zr,zi,expLr,expLi,RL;
  double invLr,invLi,udur,udui,eRL,expLrm1;
  int i,itt;
  FILE *sort,*sorti;
void deriv1(double ft[],double ft1[],int m);
void dfour1(double ft[] ,int m,int o);
void deriv1alia(double ft[],double ft1[],int m);
void deriv2(double ft[],double ft2[],int m);
  


/* on transvaseet Re[TFu]=u; Im[TFu]=0 */ 
  for (i=0; i<=nx;i++)
 {TFu[2*i+1]=u[i];
  TFu[2*i+2]=0;} 
/* transforme fourier un tableau "TFu" */
  dfour1(TFu,nx,1); 
/* on construit ik u->TF(du/dx), on aliasage a 2/3 !! */
  deriv1alia(TFu,TFdu,nx);
/* on erevient dans l'espace physique, on divise donc par nx */ 
  dfour1(TFdu,nx,-1);
  for (i=1; i<=2*nx;i++){TFdu[i]=TFdu[i]/nx;}
/* ce serait aussi une possibilite? convlv(TFdu,nx,TFdu,nx,1,ans);*/
/* on en prend le  udu  /dx dans l'espace physique */ 
  for (i=0; i<nx;i++)
  {TFdu2[2*i+1]=(UN+3./2.*u[i]*epsilon)*TFdu[2*i+1]*(Pi/Lx);
  /* (Pi/Lx) pour etre entre -L et L*/
   TFdu2[2*i+2]=0; }
/* que l'on re-fourier */
  dfour1(TFdu2,nx,1);;
  /* ==============================================================  */
/* $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ */
/*                          evolution de chaque mode                 */
 
i=0;

TFu[2*i+1]=TFu[2*i+1]-dt*(1)*TFdu2[2*i+1];
TFu[2*i+2]=TFu[2*i+2]-dt*(1)*TFdu2[2*i+2];
 for (i=1; i<=nx/2;i++)
  {k=i;

/* ici on change on implicite en temps et explicite en udu/dx   */

 #define nexp   
#ifdef nexp
/* du/dt = L u   dans                    */
   ur= TFu[2*i+1] +dt*(-TFdu2[2*i+1]);
   ui= TFu[2*i+2] +dt*(-TFdu2[2*i+2]);
   
   Lr= 36/(36 + Power(delta2,2)*Power(dt,2)*Power(k,6) +  
     72*dt*Power(k,2)*visc + 36*Power(dt,2)*Power(k,4)*Power(visc,2)) + 
     36*dt*Power(k,2)*visc/
     (36 + Power(delta2,2)*Power(dt,2)*Power(k,6) + 
     72*dt*Power(k,2)*visc + 36*Power(dt,2)*Power(k,4)*Power(visc,2));
   Li=-6* delta2*dt*Power(k,3)/ 
     (36 + Power(delta2,2)*Power(dt,2)*Power(k,6) + 
     72*dt*Power(k,2)*visc + 36*Power(dt,2)*Power(k,4)*Power(visc,2));
  
   TFu[2*i+1]=ur*Lr-ui*Li;
   TFu[2*i+2]=ur*Li+ui*Lr; 
  
  #else
/* du/dt = L u   dans le cas lineaire de KS, ou L.=-4*d4./dx4 -a d2./dx2   */
/* s'integre exactement   */
/* ici   L=(-delta2 /6*pow( -I k,3) - visc*k*k);                           */
/*du/dt = L u  + s; s est le terme non lineaire                            */
/*  d'ou l'exponentielle (L'astuce est dans Frish She Thual 86             */
/*printf("                                            \n");
 printf("                            Ldt             \n");
 printf("               Ldt         e    - 1         \n");
 printf("     u(t+dt)= e   u(t) +s ---------         \n");
 printf("                                L           \n");*/
/* avec        1/L = (Lr- i Li)/(Lr*Lr + Li*Li) */

#undef BO
     Lr= - k*k*visc       ;
     Li= - delta2/6*k*k*k   ;
#ifdef BO
     Li= - delta2/6*k*k*k  - k*k*(Pi/Lx)*(Pi/Lx);
#endif     
     eRL  = exp(Lr*dt);  
     expLr= eRL*cos(dt*Li);
     expLi= eRL*sin(dt*Li);
     
     RL=Lr*Lr+Li*Li;
     invLr=  Lr/RL;
     invLi= -Li/RL;     
     expLrm1=expLr-1; 
     
     zr=invLr*expLrm1 - invLi*expLi  ;
     zi=invLr*expLi   + invLi*expLrm1  ;  
     
     udur= (-TFdu2[2*i+1]);
     udui= (-TFdu2[2*i+2]);  
        
     ur= TFu[2*i+1];
     ui= TFu[2*i+2];
     
     TFu[2*i+1]=ur*expLr - ui*expLi + zr*udur - zi*udui ;
     TFu[2*i+2]=ur*expLi + ui*expLr + zr*udui + zi*udur  ;
    
#endif     
  



#ifdef BO
       Lr= - k*k*visc       ;
       Li= + delta2/6*k*k*k  + k*k*(Pi/Lx)*(Pi/Lx);
     
     eRL  = exp(Lr*dt);  
     expLr= eRL*cos(dt*Li);
     expLi= eRL*sin(dt*Li);
     
     RL=Lr*Lr+Li*Li;
     invLr=  Lr/RL;
     invLi= -Li/RL;     
     expLrm1=expLr-1; 
     
     zr=invLr*expLrm1 - invLi*expLi  ;
     zi=invLr*expLi   + invLi*expLrm1  ;  
     
     udur= (-TFdu2[2*(nx-i)+1]);
     udui= (-TFdu2[2*(nx-i)+2]);  
        
     ur= TFu[2*(nx-i)+1];
     ui= TFu[2*(nx-i)+2];
     
     TFu[2*(nx-i)+1]=ur*expLr - ui*expLi + zr*udur - zi*udui ;
     TFu[2*(nx-i)+2]=ur*expLi + ui*expLr + zr*udui + zi*udur  ;
#else
/* autres modes -> conjugue! car on travaille sur une fction Reelle  */
   TFu[2*(nx-i)+1]= TFu[2*i+1];
   TFu[2*(nx-i)+2]=-TFu[2*i+2];
#endif
    }
/* $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ */
 
/* on repasse dans l'espace physique                                 */
   dfour1(TFu,nx,-1); 
/*   dfour1(TFdu2,nx,-1);*/ /*pour controle; obsolete */
   for (i=1; i<=2*nx;i++)
  {TFu[i]=TFu[i]/nx;/*ans[i]=ans[i]/nx;*/}
 for (i=0; i<=nx-1;i++){u[i]=TFu[2*i+1];/*uo[i]=ans[2*i+1];*/}  
}


/* %%%%%%%%*$^$^$^$**^****^$^$*$*$^$^/;;:;:;:+*=$$$ ^$$$$ */
/* ================================================================  */   
void deriv1alia(double ft[],double ft1[],int nx)
{    int i;
/* derivee premiere avec aliesage */
 ft1[1]=0;
 ft1[2]=0;
 for (i=1; i<=(2)*nx/3/2;i++)
 {
  ft1[2*i+1]=+i *ft[2*i+2];
  ft1[2*i+2]=-i *ft[2*i+1];
  ft1[2*(nx-i)+1]=-(i)*ft[2*(nx-i)+2];
  ft1[2*(nx-i)+2]=+(i)*ft[2*(nx-i)+1];
 }
 for (i=(2)*nx/3/2+1;i<=nx/2;i++)
 {
  ft1[2*i+1]=0;
  ft1[2*i+2]=0;
  ft1[2*(nx-i)+1]=0;
  ft1[2*(nx-i)+2]=0;
 }
}
/* ================================================================  */ 
void deriv1(double ft[],double ft1[],int nx)
{    int i;
/* derivee 1 simple */
 ft1[1]=0;
 ft1[2]=0;
 for (i=1; i<=nx/2;i++)
 {
  ft1[2*i+1]=+i *ft[2*i+2];
  ft1[2*i+2]=-i *ft[2*i+1];
  ft1[2*(nx-i)+1]=-(i)*ft[2*(nx-i)+2];
  ft1[2*(nx-i)+2]=+(i)*ft[2*(nx-i)+1];
 }
}
/* ================================================================  */ 
void deriv2(double ft[],double ft2[],int nx)
{    int i;
/* derivee 2*/
 ft2[1]=0;
 ft2[2]=0;
 for (i=1; i<=nx/2;i++)
 {
  ft2[2*i+1]=-i*i *ft[2*i+1];
  ft2[2*i+2]=-i*i *ft[2*i+2];
  ft2[2*(nx-i)+1]=-(i*i)*ft[2*(nx-i)+1];
  ft2[2*(nx-i)+2]=-(i*i)*ft[2*(nx-i)+2];
 }
}
/* ================================================================  */  
 
/* CL CL CL CL CL CL CL CL CL  */
